import * as React from 'react';
export interface IDraggableListProps {
    /** 数据数组 */
    dataSource: Object[];
    /** 数据数组 key 值 */
    rowKey: string;
    /** 数据项 */
    row: (record: Object, index: number) => React.ReactElement<any>;
    /** 是否禁用拖拽 */
    disabled?: boolean;
    /** 是否显示拖拽指示点 */
    handles?: boolean;
    /** 列表项重排时移动的动画时间 */
    animation?: number;
    /** 列表排序改变的回调 */
    onUpdate?: (event: Object, dataSource: Object[]) => void;
    /** className */
    className?: string;
    /** row className */
    rowClassName?: string;
    /** drop placeholder className */
    ghostClass?: string;
    /** chosen item className */
    chosenClass?: string;
    /** dragClass className */
    dragClass?: string;
    /** 行内样式 */
    style?: React.CSSProperties;
    prefixCls?: string;
}
export default class DraggableList extends React.Component<IDraggableListProps, any> {
    static defaultProps: {
        disabled: boolean;
        handles: boolean;
        animation: number;
        prefixCls: string;
    };
    _current: Object[];
    _sortableGroupDecorator: (componentBackingInstance: any) => void;
    render(): JSX.Element;
}
